%loading..
load data.flt
x=data(:,1);
y=data(:,2);


%mazani zbytecnosti.....
clear data;

%kubicky interpolacni spline ve tvaru piecewise polynomial......
pp=splinev(x',y',0.017*ones(size(x')));


%vektor pro kresleni grafu.......
xx=linspace(min(x),max(x),1000);


%vypocet splinem interpolovanych hodnot........
yy0=ppval(pp,xx);

%koeficienty prvni analyticke derivace.........
[breaks,coefs,l,k]=unmkpp(pp);
clear pp;
m=size(coefs,1);
clear l;
clear k;
coefs1=coefs(:,1:3).*(ones(m,1)*[3:-1:1]);
pp1=mkpp(breaks,coefs1);


%vypocet prvni derivace.........
yy1=ppval(pp1,xx);
clear pp1;

%koeficienty druhe analyticke derivace...........
coefs2=coefs1(:,1:2).*(ones(m,1)*[2:-1:1]);
pp2=mkpp(breaks,coefs2); 

%vypocet prvni derivace...........
yy2=ppval(pp2,xx);
clear pp2;

%malovani...............
figure(1);
plot(xx,yy0,x,y,'g+');
title('vstupni data');
figure(2);
plot(xx,yy1);
title('prvni derivace');
figure(3);
plot(xx,-yy2);
title('druha derivace');
