function y=imgaussfilt(x,h) ;
% Filter image with Gaussian filter of effective width 2h
% in x direction
%
% $Id: imgaussfilt.m,v 1.1 2000/04/19 17:03:06 jkybic Exp $
% J.K., November 1998

sz=ceil(4*h) ;
flt=-sz:sz ;
cnt=sz+1 ;
flt=exp(-flt.^2/2/h^2)/sqrt(2*pi)/h ;
n=size(x,1) ;
y=x ;
for i=1:n,
  tmp=conv(double(x(i,:)),flt) ;
  y(i,:)=tmp(1+sz:length(tmp)-sz) ;
end ;  