function y=imhisteq(r,t)
% Make a histogram of a test image t equal to the histogram of a reference
% image r. Assume the images are normalized between 0 and 1.
% 
% Usage: y=imhisteq(r,t)

nr=prod(size(r)) ;
hr=hist(reshape(r,1,nr),ceil(sqrt(nr))) ;
y=histeq(t,hr) ;
