function w=lndpereval(p,x,c) ;
% Evaluate a thin-plate spline at (2D) point p given coefficients c
% and landmark locations x
%
% Usage:  w=lndthseval(p,x,c) 
%
% $Id: lndpereval.m,v 1.1 2000/01/27 18:11:53 jkybic Exp $
% Jan Kybic, 1999

w=0 ;
n=length(c)-1 ;

for i=1:n,
    w=w+rlogrper(x(i,1)-p(1),x(i,2)-p(2),1)  ;
end ;

w=w+c(n+1) ;

