% Test the thin-plate spline landmark interpolation
% show the dependence on alpha

x=[ 1.5 ; 2  ; 4 ; 5 ; 5.5 ; 6 ] ;
x2=2 ;
x=[x x2*ones(length(x),1)] ;
z=[ 1 ; -2 ; 5 ; 1; 4 ; -3 ] ;

%c=lndthscoef(x,z) ;
t=1:0.05:6.5 ; 
N=length(t) ;

% t=-10:0.1:10 ; 
%x2=2 ;
%y1=t ;
%for i=1:N,
%    y1(i)=lndthseval([ t(i) x2],x,c) ;
%end ;
  
svm=[ 0.6 1 2 3 ] ;
alphav=2*svm-1 ;
nal=length(alphav) ;
y2=zeros(nal,N) ;
for k=1:nal,
  alpha=alphav(k) ;
  c2=lndradcoef(x,z,alpha) ;
  for i=1:N,
    y2(k,i)=lndradeval([ t(i) x2],x,c2,alpha) ;
  end ;
end ;
%plot(x(:,1),z,'o',t,y2,'k-') ; 
plot(x(:,1),z,'k*',t,y2(1,:),'k-',t,y2(2,:),'k-.',t,y2(3,:),'k--',...
    t,y2(4,:),'k:') ; 
%legend('Samples','M+s=0.6','M+s=1','M+s=2','M+s=3') 
legend('Samples','M=0.6','M=1','M=2','M=3') 
axis([1 6.5 -6 8]) ;
h=findobj(gca,'Type','line','Marker','*')
set(h,'LineWidth',3) ;
print -deps showalphdep.eps