% Test the thin-plate spline landmark interpolation

x=[ 1 2 ; 1 1 ; 2 2 ; 3 4 ; 2 3 ; 3 2 ] ;
z=[ 1 ; 1 ; 2 ; 3; 4 ; 5 ] ;

c=lndthscoef(x,z) ;
t=1:0.1:3 ; 
% t=-10:0.1:10 ; 
x2=2 ;
N=length(t) ;
y1=t ;
for i=1:N,
    y1(i)=lndthseval([ t(i) x2],x,c) ;
end ;
  
alpha=3.5;
c2=lndthscoef(alpha*x,z) ;
y2=t ;
for i=1:N,
    y2(i)=lndthseval(alpha*[ t(i) x2],alpha*x,c2) ;
end ;
sum(c2(1:6)) ;
plot(t,y1,t,y2) ;