function tryx3wav 
% Try to construct a zero mean (wavelet like), compactly supported 
% function out of |x-k|^3

%c=[1 -4 6 -4 1]' ;

%pp=0:5 ;
%AA=[ pp.^0 ; pp.^1 ; pp.^2 ; pp.^3 ; pp.^4 ; 1 0 0 0 0 0 ] ;
%c=AA\[0 ; 0 ; 0 ; 0 ; 0 ; 1] ;
%a=0 ; b=0 ;

%c=c(4:6) ;
%c=[ 1 -2 1 ]' ; a=-6 ; b=6 ; g=(0:2)' ;
c=[ 1 -2 1 ]' ; a=6 ; b=-18 ; g=(2:4)' ;
%c=[ 1 -5 10 -10 5 -1]' ; a=0 ; b=0 ;
N=length(c) ;
%g=((1:N)-(N+1)/2)' ;
%g=((1:N)-1)' ;
t=-10:0.1:10 ;
T=length(t) ;
NN=10 ;
g=0:NN-1 ;
C=zeros(NN,2+NN) ;
C(1,1:5)=[ -6 6 1 -2 1 ] ;
C(1,1:6)=[ -6 12 0 1 -2 1 ] ;
C(1,1:7)=[ -6 18 0 0 1 -2 1 ] ;
for i=4:NN-3,
  C(i,i+2:i+7)=[ 1 -5 10 -10 5 -1] ;
end ;
for i=NN-2:NN,
  C(i,1:2)=[ -6 6*g(i+1) ] ;
  %% to finish here
  C(i,i:i+2)=[ 
C(1,1:5)=[ -6 6 1 -2 1 ] ;
C(1,1:6)=[ -6 12 0 1 -2 1 ] ;
C(1,1:7)=[ -6 18 0 0 1 -2 1 ] ;




y=zeros(NN,T) ;
for i=1:NN,
  y(i,:)=evallc(c,a,b,g,t) ;
end ;

plot(t,y) ;
grid on ;

function y=evallc(c,a,b,g,t) ;
T=length(t) ;
y=zeros(1,T) ;
for i=1:T,
  y(i)=c'*(abs(t(i)-g)).^3+a*t(i)+b ;
end ;

