/*
 * MATLAB Compiler: 2.0
 * Date: Wed Sep 29 13:49:36 1999
 * Arguments: "-x" "-h" "lndradimg.m" 
 */

#ifndef MLF_V2
#define MLF_V2 1
#endif

#include "matlab.h"
#include "filiirs.h"
#include "fspline.h"
#include "mexsplninterp.h"
#include "lndradeval.h"
#include "lndradcoef.h"
#include "fsplinem.h"
#include "lndradimg.h"

static mlfFunctionTableEntry function_table[5]
  = { { "fspline", mlxFspline, 2, 1 },
      { "lndradeval", mlxLndradeval, 4, 1 },
      { "lndradcoef", mlxLndradcoef, 3, 1 },
      { "fsplinem", mlxFsplinem, 2, 1 },
      { "lndradimg", mlxLndradimg, 4, 1 } };

static mxArray * Mfiliirs(int nargout_, mxArray * varargin) {
    mxArray * varargout = mclGetUninitializedArray();
    mclFevalCallMATLAB(
      mclNVarargout(nargout_, 1, &varargout, NULL),
      "filiirs",
      mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()), NULL);
    return varargout;
}

static mxArray * Mmexsplninterp(int nargout_, mxArray * varargin) {
    mxArray * varargout = mclGetUninitializedArray();
    mclFevalCallMATLAB(
      mclNVarargout(nargout_, 1, &varargout, NULL),
      "mexsplninterp",
      mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()), NULL);
    return varargout;
}

/*
 * The function "mexFunction" is a Compiler-generated mex wrapper, suitable for
 * building a MEX-function. It initializes any persistent variables as well as
 * a function table for use by the feval function. It then calls the function
 * "mlxLndradimg". Finally, it clears the feval table and exits.
 */
void mexFunction(int nlhs, mxArray * * plhs, int nrhs, mxArray * * prhs) {
    mlfTry {
        mlfFunctionTableSetup(5, function_table);
        mclImportGlobal(0, NULL);
        mlxLndradimg(nlhs, plhs, nrhs, prhs);
        mlfFunctionTableTakedown(5, function_table);
    } mlfCatch {
        mlfFunctionTableTakedown(5, function_table);
        mclMexError();
    } mlfEndCatch
}

void mlxFiliirs(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    mlfEnterNewContext(0, 0);
    mprhs[0] = NULL;
    mlfAssign(&mprhs[0], mclCreateVararginCell(nrhs, prhs));
    mplhs[0] = Mfiliirs(nlhs, mprhs[0]);
    mclAssignVarargoutCell(nlhs, plhs, mplhs[0]);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(mprhs[0]);
}

mxArray * mlfNFiliirs(int nargout, mlfVarargoutList * varargout, ...) {
    mxArray * varargin = mclUnassigned();
    mlfVarargin(&varargin, varargout, 0);
    mlfEnterNewContext(0, -1, varargin);
    nargout += mlfNargout(varargout);
    *mlfGetVarargoutCellPtr(varargout) = Mfiliirs(nargout, varargin);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
    return mlfAssignOutputs(varargout);
}

mxArray * mlfFiliirs(mlfVarargoutList * varargout, ...) {
    mxArray * varargin = mclUnassigned();
    int nargout = 0;
    mlfVarargin(&varargin, varargout, 0);
    mlfEnterNewContext(0, -1, varargin);
    nargout += mlfNargout(varargout);
    *mlfGetVarargoutCellPtr(varargout) = Mfiliirs(nargout, varargin);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
    return mlfAssignOutputs(varargout);
}

void mlfVFiliirs(mxArray * synthetic_varargin_argument, ...) {
    mxArray * varargin = mclUnassigned();
    mxArray * varargout = mclUnassigned();
    mlfVarargin(&varargin, synthetic_varargin_argument, 1);
    mlfEnterNewContext(0, -1, varargin);
    varargout = Mfiliirs(0, synthetic_varargin_argument);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
}

void mlxMexsplninterp(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    mlfEnterNewContext(0, 0);
    mprhs[0] = NULL;
    mlfAssign(&mprhs[0], mclCreateVararginCell(nrhs, prhs));
    mplhs[0] = Mmexsplninterp(nlhs, mprhs[0]);
    mclAssignVarargoutCell(nlhs, plhs, mplhs[0]);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(mprhs[0]);
}

mxArray * mlfNMexsplninterp(int nargout, mlfVarargoutList * varargout, ...) {
    mxArray * varargin = mclUnassigned();
    mlfVarargin(&varargin, varargout, 0);
    mlfEnterNewContext(0, -1, varargin);
    nargout += mlfNargout(varargout);
    *mlfGetVarargoutCellPtr(varargout) = Mmexsplninterp(nargout, varargin);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
    return mlfAssignOutputs(varargout);
}

mxArray * mlfMexsplninterp(mlfVarargoutList * varargout, ...) {
    mxArray * varargin = mclUnassigned();
    int nargout = 0;
    mlfVarargin(&varargin, varargout, 0);
    mlfEnterNewContext(0, -1, varargin);
    nargout += mlfNargout(varargout);
    *mlfGetVarargoutCellPtr(varargout) = Mmexsplninterp(nargout, varargin);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
    return mlfAssignOutputs(varargout);
}

void mlfVMexsplninterp(mxArray * synthetic_varargin_argument, ...) {
    mxArray * varargin = mclUnassigned();
    mxArray * varargout = mclUnassigned();
    mlfVarargin(&varargin, synthetic_varargin_argument, 1);
    mlfEnterNewContext(0, -1, varargin);
    varargout = Mmexsplninterp(0, synthetic_varargin_argument);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
}
