/*
 * MATLAB Compiler: 2.0
 * Date: Tue Feb  8 17:18:52 2000
 * Arguments: "-x" "lndthsimgder" 
 */

#ifndef MLF_V2
#define MLF_V2 1
#endif

#include "matlab.h"
#include "mexsplninterp.h"
#include "fsplinem.h"
#include "lndthsimgder.h"

static mlfFunctionTableEntry function_table[1]
  = { { "lndthsimgder", mlxLndthsimgder, 3, 1 } };

static mxArray * Mmexsplninterp(int nargout_, mxArray * varargin) {
    mxArray * varargout = mclGetUninitializedArray();
    mclFevalCallMATLAB(
      mclNVarargout(nargout_, 1, &varargout, NULL),
      "mexsplninterp",
      mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()), NULL);
    return varargout;
}

static mxArray * Mfsplinem(int nargout_, mxArray * x, mxArray * order) {
    mxArray * c = mclGetUninitializedArray();
    mclFevalCallMATLAB(
      mclNVarargout(nargout_, 0, &c, NULL), "fsplinem", x, order, NULL);
    return c;
}

/*
 * The function "mexFunction" is a Compiler-generated mex wrapper, suitable for
 * building a MEX-function. It initializes any persistent variables as well as
 * a function table for use by the feval function. It then calls the function
 * "mlxLndthsimgder". Finally, it clears the feval table and exits.
 */
void mexFunction(int nlhs, mxArray * * plhs, int nrhs, mxArray * * prhs) {
    mlfTry {
        mlfFunctionTableSetup(1, function_table);
        mclImportGlobal(0, NULL);
        mlxLndthsimgder(nlhs, plhs, nrhs, prhs);
        mlfFunctionTableTakedown(1, function_table);
    } mlfCatch {
        mlfFunctionTableTakedown(1, function_table);
        mclMexError();
    } mlfEndCatch
}

void mlxMexsplninterp(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    mlfEnterNewContext(0, 0);
    mprhs[0] = NULL;
    mlfAssign(&mprhs[0], mclCreateVararginCell(nrhs, prhs));
    mplhs[0] = Mmexsplninterp(nlhs, mprhs[0]);
    mclAssignVarargoutCell(nlhs, plhs, mplhs[0]);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(mprhs[0]);
}

mxArray * mlfNMexsplninterp(int nargout, mlfVarargoutList * varargout, ...) {
    mxArray * varargin = mclUnassigned();
    mlfVarargin(&varargin, varargout, 0);
    mlfEnterNewContext(0, -1, varargin);
    nargout += mlfNargout(varargout);
    *mlfGetVarargoutCellPtr(varargout) = Mmexsplninterp(nargout, varargin);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
    return mlfAssignOutputs(varargout);
}

mxArray * mlfMexsplninterp(mlfVarargoutList * varargout, ...) {
    mxArray * varargin = mclUnassigned();
    int nargout = 0;
    mlfVarargin(&varargin, varargout, 0);
    mlfEnterNewContext(0, -1, varargin);
    nargout += mlfNargout(varargout);
    *mlfGetVarargoutCellPtr(varargout) = Mmexsplninterp(nargout, varargin);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
    return mlfAssignOutputs(varargout);
}

void mlfVMexsplninterp(mxArray * synthetic_varargin_argument, ...) {
    mxArray * varargin = mclUnassigned();
    mxArray * varargout = mclUnassigned();
    mlfVarargin(&varargin, synthetic_varargin_argument, 1);
    mlfEnterNewContext(0, -1, varargin);
    varargout = Mmexsplninterp(0, synthetic_varargin_argument);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
}

void mlxFsplinem(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: fsplinem Line: 1 Column:"
            " 0 The function \"fsplinem\" was called with m"
            "ore than the declared number of outputs (1)"));
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: fsplinem Line: 1 Column:"
            " 0 The function \"fsplinem\" was called with m"
            "ore than the declared number of inputs (2)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mfsplinem(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}

mxArray * mlfFsplinem(mxArray * x, mxArray * order) {
    int nargout = 1;
    mxArray * c = mclGetUninitializedArray();
    mlfEnterNewContext(0, 2, x, order);
    c = Mfsplinem(nargout, x, order);
    mlfRestorePreviousContext(0, 2, x, order);
    return mlfReturnValue(c);
}
