function y=normalize(x)
% Normalize x to take values between 0 and 1. Return result in y
% Linear scaling 
%
% Jan Kybic, November 1998
%
% Usage: y=normalize(x) 

x=double(x) ;
y=x-min(min(min(min(x)))) ;
m=max(max(max(max(y)))) ;
if m==0, m=1 ; end ;
y=y/m ;