% Show spect images

ecd=readnema('/home/jkybic/uge/sujet-A_TRA_OM-r199907091706.nema',...
[128 128 35]) ;

clf=size(colormap,1) ;

ecd=normalize(ecd)*clf ;
nx=size(ecd,2) ; ny=size(ecd,1) ; nz=size(ecd,3)-1 ;
img=zeros(6*ny,6*nx) ;
figure(1) ; clf ;
%for i=1:size(ecd,3)-1,
%  subplot(6,6,i) ;
% image(squeeze(ecd(:,:,i))) ; axis off ; axis fill ; colormap gray ;
%end ;

for i=1:6,
  for j=1:6,
    n=i+6*(j-1) ;
    if n<=nz, img((j-1)*ny+1:j*ny,(i-1)*nx+1:i*nx)=ecd(:,:,n) ;
    end ;
  end ;
end ;

image(img) ; axis off ; colormap gray ;
print -deps '/home/jkybic/tex/icip2000/showspectfig1.eps'

figure(2) ;
%clear all
load epapar1
load regepa19
disp('bsplntransf') ;
epAb=fsplinem(epA,degft) ;
epC=ecd ;
epCb=fsplinem(epC,degft) ;
disp('deftable') ;
tbl=deftable(c1,imsize,degc) ;
disp('splninterp') ;
epAd=mexsplninterp(epAb,tbl,3,degft) ;
disp('deftable') ;
tbl2=deftable(c2,imsize,degc) ;
disp('splninterp') ;
epAw=mexsplninterp(epAb,tbl2,3,degft) ;

subplot(211) ; imagesc([ epAd(:,:,10) epA(:,:,10)]) ; 
axis off ;
title('reference/test') ; colormap(gray) ;
subplot(212) ; imagesc([ epAd(:,:,10)-epA(:,:,10) epAd(:,:,10)-epAw(:,:,10)]) ;
title('before/after') ; colormap(gray) ;
axis off ;
print -deps '/home/jkybic/tex/icip2000/showspectfig2.eps'

figure(3)
% Xenon SPECT test and reference
imagesc([ epAd(:,:,10) epA(:,:,10) ]) ;
axis image ; axis off ; colormap(gray)
print -deps '/home/jkybic/tex/icip2000/showspectfig3.eps'

% Xenon SPECT image difference before and after
imagesc([ epAd(:,:,10)-epA(:,:,10) epAd(:,:,10)-epAw(:,:,10)]) ;
axis image ; axis off ; colormap(gray)
print -deps '/home/jkybic/tex/icip2000/showspectfig4.eps'

disp('deftable') ;
tbl=deftable(c1,size(epC),degc) ;
disp('splninterp') ;
epCd=mexsplninterp(epCb,tbl,3,degft) ;
% ECD SPECT test and reference
imagesc([ epCd(:,:,20) epC(:,:,20) ]) ;
axis image ; axis off ; colormap(gray)
print -deps '/home/jkybic/tex/icip2000/showspectfig5.eps'
