% Read volume data with readnema

ecdA=readnema('/home/jkybic/uge/sujet-A_TRA_OM-r199907091706.nema',[128 128 35]) ;
ecdA=ecdA(:,:,1:34) ;

ecdB=readnema('/home/jkybic/uge/sujet-B_TRA_OM-r199907081155.nema',[128 128 33]) ;
% ecdB=ecdB(:,:,1:34) ;

epA=readnema('/home/jkybic/uge/sujet-A_EP-r199907091642.nema',[64 64 18]) ;
epA=epA(:,:,1:17) ;
epB=readnema('/home/jkybic/uge/sujet-B_EP-r199907081128.nema',[64 64 18]) ;
epB=epB(:,:,1:17) ;

spA=readnema('/home/jkybic/uge/sujet-A_SP-r199907091642.nema',[64 64 18]) ;
spA=spA(:,:,1:17) ;
spB=readnema('/home/jkybic/uge/sujet-B_SP-r199907081128.nema',[64 64 18]) ;
spB=spB(:,:,1:17) ;

subplot(321) ; imagesc(ecdA(:,:,10)) ; title('ecdA') ; colormap(pink) ;
subplot(322) ; imagesc(ecdB(:,:,10)) ; title('ecdB') ; 
subplot(323) ; imagesc(epA(:,:,6)) ; title('epA') ; 
subplot(324) ; imagesc(epB(:,:,6)) ; title('epB') ; 
subplot(325) ; imagesc(spA(:,:,6)) ; title('spA') ; 
subplot(326) ; imagesc(spB(:,:,6)) ; title('spB') ; 

% Try to register
c0=zeros(3,4,4,4) ; alpha=1e-3 ;
cc=cputime ;
ecdA=ecdA(:,:,1:33) ;
c1=regoptpyr(ecdA,ecdB,c0,alpha,4) ;
disp([ ' regoptpyr took ' num2str(cputime-cc) ' s']) ;
