function y=evalmbspline(x,c,T,d,deg) 
% evaluate spline function f(x)=sum_{i=1}^N c_i beta_deg(x/T-i+d)
% at points x
%
% Jan Kybic, February 2000
% $Id: evalmbspline.m,v 1.1 2000/02/01 15:30:24 jkybic Exp $

N=length(c) ;
m=length(x) ;
y=zeros(1,m);
for k=1:N,
  y=y+c(k)*evalbspline(x/T-k+d,deg) ;
end ;


