function y=evalrbfsplnapr(x,c,T,d,der)
% Evaluate approximation calculated in rbfslpnapr in points x
%
%

if nargin<5, der=0 ; end ;

x=x(:) ; y=x ;
NN=length(c) ; N=NN-4 ;
m=length(x) ;

if der==0,
  for i=1:m,
    xt=x(i) ;
    tmp=c(N+1)+xt*(c(N+2)+xt*(c(N+3)+c(N+4)*xt)) ;
    for j=1:N,
      tmp=tmp+c(j)*abs(xt-j/T+d)^7 ;
    end ;
    y(i)=tmp ;
  end ;
elseif der==1,
  for i=1:m,
    xt=x(i) ;
    tmp=c(N+2)+xt*(2*c(N+3)+3*c(N+4)*xt) ;
    for j=1:N,
      tmp=tmp+7*c(j)*sign(xt-j/T+d)*abs(xt-j/T+d)^6 ;
    end ;
    y(i)=tmp ;
  end ;
elseif der==2,  
  for i=1:m,
    xt=x(i) ;
    tmp=c(N+3)*2+c(N+4)*6*xt ;
    for j=1:N,
      tmp=tmp+42*c(j)*abs(xt-j/T+d)^5 ;
    end ;
    y(i)=tmp ;
  end ;
else
  error('Incorrect value for the derivative, should be 0,1,2') ;
end ;  


