% Tests sdcgr
%
% $Id: trysdcgr.m,v 1.17 1999/11/25 11:11:51 jkybic Exp $

if 0,
figure(1) ; title('1D test') ;
img=[ 10 5 4 3 3 6 8 2 1 10 ]' ; 
imsize=length(img) ;
imgb=fsplinem(img,3) ;
c=[ 0 0 1 0 0 ]' ;
tbl=deftable(c,imsize,3) ;
imgw=mexsplninterp(imgb,tbl,1,3) ;
plot(1:imsize,img,1:imsize,imgw) ;
c0=[ 0 0 0.99 0 0 ]' ;
% c0=[ 1 0 1 0 1 ]' ;
h=1e-6 ; c1=c0+[ h 0 0 0 0]' ;
[E,gr,H]=sdcgr(imgw,imgb,c0,3,3) ; E,gr
% [E,gr,H1]=mexsdcgr(imgw,imgb,c0,3,3) ; E,gr
% H=reshape(H,length(c0),length(c0)) ;
% H, H1
[E1,gr1]=sdcgr(imgw,imgb,c1,3,3) 
(E1-E)/h 
end ;

if 0,
figure(2) ; title('2D test') ;
% img=double(imread('/home/jkybic/people/philippe/reg/barb.TIFF')) ;
load smallbarb
imsize=size(img) ;
c=zeros(2,4,4) ;
c(1,3,3)=50 ;
disp('Bspln transf') ;
imgb=fsplinem(img,3) ;
disp('deftable') ;
tbl=deftable(c,imsize,3) ;
disp('splninterp') ;
imgw=mexsplninterp(imgb,tbl,2,3) ; 
disp('calculating gradient') ;
imagesc(imgw) ; colormap(pink) ; axis image ;
c0=c ; c0(1,2,2)=c0(1,2,2)+1 ;
% c0=c ; c0(2,4,4)=c0(1,2,2)+1 ;
h=1e-6 ; c1=c0 ; c1(1,3,2)=c1(1,3,2)+h ;
[E,gr,H]=sdcgr(imgw,imgb,c0,3,3) ; E,squeeze(gr(1,:,:))
[E1,gr1,H1]=mexsdcgr(imgw,imgb,c0,3,3) ; 
gr1=reshape(gr1,size(c0)) ;
E1,squeeze(gr1(1,:,:))
H1=reshape(H1,[size(c0) size(c0)]) ;
squeeze(H(2,3,1,2,:,:)) 
squeeze(H1(2,3,1,2,:,:)) 
% gr(1,3,2)
% [E1,gr1]=sdcgr(imgw,imgb,c1,3,3) ; 
% (E1-E)/h 
end ;

if 1,
figure(3) ;title('3D test') ;
load smallbarb
img1=img ;
load smalleinst ;
img2=img ; 
[ny,nx]=size(img1) ;
img=zeros(ny,nx,2) ;
img(:,:,1)=double(img1) ; img(:,:,2)=double(img2) ;
imsize=size(img) ;
imsize=size(img) ;
c=zeros(3,4,4,4) ;
%c=zeros(3,6,6,6) ;
c(3,2,3,2)=20 ;
c(3,3,3,3)=-4 ;
disp('Bspln transf') ;
imgb=fsplinem(img,3) ;
disp('deftable') ;
tbl=deftable(c,imsize,3) ;
disp('splninterp') ;
imgw=mexsplninterp(imgb,tbl,3,3) ; 
disp('displaying') ;
subplot(111) ; imagesc([ imgw(:,:,1) imgw(:,:,2) ]) ; 
colormap(pink) ; axis image ;
c0=c ; c0(1,2,3,2)=c0(1,2,3,2)+1 ;
h=1e-6 ; c1=c0 ; c1(1,2,2,2)=c1(1,2,2,2)+h ;
% [E,gr,H]=sdcgr(imgw,imgb,c0,3,3) ;
cc=cputime ;
[E1,gr1,H1]=mexsdcgr(imgw,imgb,c0,3,3) ;
disp(['mexsdcgr took ' num2str(cputime-cc) ' s' ]) ;
% gr1=reshape(gr1,size(c0)) ;
H1=reshape(H1,[size(c0) size(c0)]) ;
% E
% E1
% gr(1,2,2,2)
% gr1(1,2,2,2)
% squeeze(H(2,3,4,2,2,3,:,:))
squeeze(H1(2,3,4,2,2,3,:,:))
%[E1,gr1]=sdcgr(imgw,imgb,c1,3,3) ; 
%(E1-E)/h 
end ;
