% Test splninterpone

% 1D
if 0,
figure(1) ;
t=(-10:0.1:10)' ;
N=5 ;c=zeros(N,1) ;
n=1 ; c(n+1)=1 ; 
y=mexsplninterp(c,t,1,3) ;
y1=splninterpone(n,N,t,1,3) ; plot(t,y,t,y1) ; grid on ;
end ;

% 2D
if 0,
figure(2) ;
Nx=5 ; Ny=5 ;
xv=(-10:0.1:10)' ; 
yv=(-10:0.1:10)' ; 
%xv=(-5:0.1:0)' ; 
%yv=(-5:0.1:0)' ; 
[x,y]=meshgrid(xv,yv) ;
t=shiftdim( reshape([y x],length(xv),length(yv),2),2) ;
c=zeros(Nx,Ny) ;
nx=3 ; ny=2 ; c(nx+1,ny+1)=1 ;
disp('mexsplninterp') ;
y=mexsplninterp(c,t,2,3) ;
disp('splninterpone') ;
y1=splninterpone([nx ny],[Nx Ny],t,2,3) ; 
disp('displaying') ;
subplot(211) ; imagesc([ y1 y]) ; colorbar ;
subplot(212) ; imagesc(y1-y) ; colorbar ; axis image ;
end ;

% 3D
if 1,
figure(3) ; 
Nx=5 ; Ny=5 ; Nz=5 ;
xv=(0:0.1:4)' ; 
yv=(0:0.1:4)' ;
zv=(0:0.1:4)' ;
[x,y,z]=meshgrid(yv,xv,zv) ;
t=zeros(3,length(xv),length(yv),length(zv)) ;
t(1,:,:,:)=x ; t(2,:,:,:)=y ; t(3,:,:,:)=z ;
c=zeros(Nx,Ny,Nz) ;
nx=0 ; ny=0 ; nz=0 ; c(nx+1,ny+1,nz+1)=1 ;
disp('mexsplninterp') ;
y=mexsplninterp(c,t,3,3) ;
disp('splninterpone') ;
y1=splninterpone([nx ny nz],[Nx Ny Nz],t,3,3) ; 
disp('displaying') ;
sum(sum(sum((y-y1).^2)))
subplot(211) ; imagesc([ y1(:,:,10) y(:,:,10)]) ; colorbar ;
subplot(212) ; imagesc(y1(:,:,10)-y(:,:,10)) ; colorbar ; axis image ;
end ;