function E=evalfinecrit(c,i)
% Evaluates the SSD criterion with respect to the finest level images
% read from regepaimgs. i is the number of the evaluations

global evalfinecritE evalfineimsize evalfineitercnt evalfinelsti

load regepaimgs

rimsize=size(refimg) ;
c=reshape(c.*(rimsize(1)/evalfineimsize(1)),size(c0)) ;
tbl=deftable(c,rimsize,degc) ;
ndim=length(rimsize) ;
warptestimg=mexsplninterp(testimgb,tbl,ndim,degft) ;
E=sum(sum(sum((warptestimg-refimg).^2))) ; 
disp([ 'evalfinecrit E=' num2str(E) ' Eold=' num2str(evalfinecritE) ]) ;
% Update iteration number 
if i>evalfinelsti,
  evalfineitercnt=evalfineitercnt+i-evalfinelsti ;
else
  evalfineitercnt=evalfineitercnt+1 ;
end ;
evalfinelsti=i ;

if E<=evalfinecritE,
  f=fopen('evalfinecrit.log','a') ;
  fprintf(f,'%d %g %g\n',evalfineitercnt,cputime,E) ;
  fclose(f) ;
  evalfinecritE=E ;
end ;
