% Make some demonstration images for ICIP2000 paper

load epapar1
disp('deftable') ;
tbl=deftable(c1,imsize,degc) ;
load regepafine4 
disp('deftable') ;
tblc=deftable(c2,imsize,degc) ;
[cx cy cz]=meshgrid(linspace(1,imsize(1),6),linspace(1,imsize(2),6),...
    linspace(1,imsize(3),3)) ;
figure(1) ; clf ; 
daspect([ 1 1 1/3]) ;
u=squeeze(tbl(1,:,:,:)) ;
v=squeeze(tbl(2,:,:,:)) ;
w=squeeze(tbl(3,:,:,:)) ;
% coneplot(u,v,w,cx,cy,cz,2) ;
title('Original deformation') ;
h=coneplot(u,v,w,cx,cy,cz,2,'quiver') ;
campos([-355.1331 -503.8541  -39.8776 ]) ;
camtarget([30 30 12.5]) ;

figure(2) ; clf ;
daspect([ 1 1 1/3]) ;
uc=squeeze(tblc(1,:,:,:)) ;
vc=squeeze(tblc(2,:,:,:)) ;
wc=squeeze(tblc(3,:,:,:)) ;
% coneplot(u,v,w,cx,cy,cz,2) ;
title('Deformation found') ;
h=coneplot(uc,vc,wc,cx,cy,cz,2,'quiver') ;
campos([-355.1331 -503.8541  -39.8776 ]) ;
camtarget([30 30 12.5]) ;
