% Tests regopt

degc=3; degft=3 ; alpha=1e-3 ;
%%% 1D
if 0,
imgr=[ 10 5 4 3 3 6 8 2 1 10 ]' ;
imgt=[ 10 5 3 3 6 8 2 1 10 10]' ; 
degc=3; degft=3 ;
ftc=fsplinem(imgt,degft) ;
cc=cputime ;
c=regopt(imgr,imgt,[0 0 0 0 0]',alpha) ;
disp([ ' regopt took ' num2str(cputime-cc) ' s']) ;
%c=regoptpyr(imgr,imgt,[0 0 0 0 0]',alpha,2) ;
g=deftable(c,length(imgr),degc) ;
imgw=mexsplninterp(ftc,g,1,degft) ; 
plot([imgr imgt imgw]) ; legend('ref','test','warped') ;
end ;

%%% 2D
if 1,
%load smallbarb ; %imsize=size(img) ;
%I read ref image;
fid = fopen('S-AX-Clip0010-384x288-0.raw','r');
img= fread(fid,[384,288]);
st=fclose(fid);
img = transpose(img);
imsize=size(img) ;

%c0=zeros(2,4,4);
%we force one transformation
c0=zeros(2,4,4) ; c=c0 ;
c(1,3,3)=20 ;
%disp('Bspln transf') ;
imgb=fsplinem(img,3) ;
%disp('deftable') ;
%tbl=deftable(c,imsize,3) ;
%disp('splninterp') ;
%imgr=mexsplninterp(imgb,tbl,2,degft) ;
%end of forcing transformation;

%I read target image;
fid = fopen('S-AX-Clip0010-384x288-1.raw','r');
imgr= fread(fid,[384,288]);
st=fclose(fid);
imgr = transpose(imgr);
imsize=size(imgr) ;
%end of reading;

cc=cputime ;
%c1=regopt(imgr,imgr,c0,alpha) ;
c1=regoptpyr(imgr,img,c0,alpha,5) ;
disp([ ' regopt took ' num2str(cputime-cc) ' s']) ;
%cc=cputime ;
%c1=regoptpyr(imgr,img,c0,alpha,3) ;
%disp([ ' regoptpyr took ' num2str(cputime-cc) ' s']) ;
tbl=deftable(c1,imsize,degft) ;
imgw=mexsplninterp(imgb,tbl,2,degft) ;
%subplot(221) ; imagesc(img) ; colormap(pink) ; title('test') ;
subplot(221) ; imagesc(imgr) ; colormap(pink) ; title('ref') ;
subplot(222) ; imagesc(imgw) ; colormap(pink) ; title('warped') ;
subplot(223) ; imagesc(imgr-img) ; title('before') ; colorbar ;
sum(sum((imgr-img).^2))
subplot(224) ; imagesc(imgr-imgw) ; title('after') ; colorbar ;
sum(sum((imgr-imgw).^2))
end ;

%3D
if 0,
img=gensphere([12 12 12]) ;
imsize=size(img) ;
c0=zeros(3,4,4,4) ; c=c0 ;
c(1,2,3,2)=0.1 ; degft=3 ; degc=2 ;
disp('Bspln transf') ;
imgb=fsplinem(img,degft) ;
disp('deftable') ;
tbl=deftable(c,imsize,degc) ;
disp('splninterp') ;
imgr=mexsplninterp(imgb,tbl,3,degft) ;
cc=cputime ;
c1=regoptpyr(imgr,img,c0,alpha,degc) ;
disp([ ' regopt took ' num2str(cputime-cc) ' s']) ;
tbl=deftable(c1,imsize,degc) ;
imgw=mexsplninterp(imgb,tbl,2,degft) ;
end ;