% script to test lsrsplnapr

% generate data
M=50 ;
%x=rand(M,1).^3*10 ;
x=linspace(1,10,M) ; x=x(:) ;
%y=sin(x).*exp(-x.^2)+randn(M,1)*0.01 ;
y=5+x.^2+randn(M,1)*10 ;
y=y(length(y):-1:1) ;

deg=7 ; N=30 ; lambda=0.1 ;
[c,T,d]=lsrsplnapr(x,y,N,deg,lambda,4) ;

figure(1) ; 
%xx=linspace(min(x),max(x),100);
xx=linspace(-1,12,100);
yy=evalmbspline(xx,c,T,d,deg) ;
plot(x,y,'g+',xx,yy,'r-') ; legend('data','smoothed') ;

cder=conv(c,[1 -1])/2 ;
cdder=conv(c,[1 -2 1])/4 ;
cdder=cdder(2:length(cdder)-1) ; 
yyd=evalmbspline(xx,cder,T,d+0.5,deg-1) ; % shifted by half a step
yydd=evalmbspline(xx,cdder,T,d,deg-2) ;
figure(2) ;
subplot(211) ;
plot(xx,yyd) ; title('First derivative') ;
subplot(212) ;
plot(xx,yydd) ; title('Second derivative') ;
