% script to test rbfsplnapr

% generate data
M=20 ;
%x=rand(M,1).^3*10 ;
x=linspace(1,10,M) ; x=x(:) ;
y=sin(x).*exp(-x.^2/10)+randn(M,1)*0.01 ;
y=5+x.^2+randn(M,1)*0.01 ;

N=9 ; lambda=0 ;
[c,T,d]=rbfsplnapr(x,y,N,lambda) ;

figure(1) ; 
xx=linspace(min(x),max(x),100);
xx=linspace(-0,11,100);
yy=evalrbfsplnapr(xx,c,T,d) ;
plot(x,y,'g+',xx,yy,'r-') ; legend('data','smoothed') ;

yyd=evalrbfsplnapr(xx,c,T,d,1) ;
yydd=evalrbfsplnapr(xx,c,T,d,2) ;
figure(2) ;
subplot(211) ;
plot(xx,yyd) ; title('First derivative') ;
subplot(212) ;
plot(xx,yydd) ; title('Second derivative') ;
