function [f,fx,fy,fxx,fxy,fyy]=evgf(x,y) ;
% new function r^4 log(r)
r2=x*x+y*y ;
if r2>0,
  logr=log(r2)/2 ;
  f=r2^2*logr ;
  fx=x*r2*(1+4*logr) ;
  fy=y*r2*(1+4*logr) ;
  if nargout>3,
    fxx=7*x^2+y^2+4*logr*(3*x^2+y^2) ;
    fyy=7*y^2+x^2+4*logr*(3*y^2+x^2) ;
    fxy=2*x*y*(3+4*logr) ;
  end ;
else
  f=0 ; fx=0 ; fy=0 ; fxx=0 ; fyy=0 ; fxy=0 ;
end ;
