function sum=rlogrper(x,y,T) 
% calculate Sum ( exp( 2 pi i (kx+ly)/T) / (16 pi^4 (k^2+l^2)^2) )
%
% Jan Kybic, January 2000
%
% $Id: rlogrper.m,v 1.4 2000/01/27 18:11:53 jkybic Exp $

N=10 ; % number of terms considered
x=2*pi*x/T ; y=2*pi*y/T ;
sum=0.0 ; 
for k=-N:N,
  for l=-N:N,
    if k~=0 | l~=0,
      sum=sum+cos(k*x+l*y)/(k*k+l*l)^2 ;
    end ;
  end ;
end ;
sum=sum/16/pi^4  ;

