% Test the radial power function interpolation
% $Id: trylndrad.m,v 1.1 1999/10/08 08:59:59 jkybic Exp $

x=[ 1 2 ; 1 1 ; 1.5 2 ; 3 3 ; 2 2 ; 3 2 ] ;
z=[ 1 ; 2 ; 2.5 ; 3; 2 ; 1 ] ;

alphar=[0.1 0.5 1 1.5 2.1 3 5] ;
t=0.9:0.01:3.1 ; N=length(t) ;
y1=zeros(length(alphar),N) ;
for j=1:length(alphar) ;
  alpha=alphar(j) ;
  c=lndradcoef(x,z,alpha) ;
  for i=1:N,
    y1(j,i)=lndradeval([ t(i) 2],x,c,alpha) ;
  end ;
end ;

plot(t,y1') ;
grid on ;
 legend('0.1','0.5','1','1.5','2.1','3','5') ;