% Show basis function |x|^3
%
% $Id: showbasfn.m,v 1.1 2001/01/05 13:05:16 jkybic Exp $

N=16 ; % size of the image
ny=N ; nx=N ;

thetav=30*pi/180 ; % show a basis function turned be 30 degrees
u=1 ;             % and shifted by 40 pixels

T=ny/2 ; % radius of the region of interest
%T2=13 ; % radius of the clipping zone

yv=(1:ny)-((ny+1)/2) ;
xv=(1:nx)-((nx+1)/2) ;
[xt,yt]=meshgrid(xv,yv) ;
mask=(xt.^2+yt.^2<T^2) ; % generate binary mask
%mask2=(xt.^2+yt.^2<T2^2) ; % generate binary mask

c=[1 0 0 0] ; % the coefficient vector

rimg=mexbpevalthrimg(thetav,u,c,[ny nx],1) ;


ytd=yt ;
for i=1:ny,
  ytd(:,i)=yt(:,i)/(nx+1)*sqrt(T^2-yv(i)^2) ;
end ;

z=griddata(xt,yt,rimg,xt,ytd) ;

%ind=find(mask>0) ;

%xtm=xt(ind) ; ytm=yt(ind) ; 

%h=mesh(xt,ytd,z) ;
h=mesh(xt,yt,rimg) ;
%mymap=colormap ;
%mymap(2,:)=mymap(1,:) ;
%mymap(1,:)=[1 1 1] ;
%colormap(mymap) ; axis off
view(-40,16)
set(gca,'CameraViewAngle',6)
set(gca,'CameraTarget',[0 0 7])
axis off ; hidden off ;
%h=mesh(xt,yt,rimg) ; axis off ;
%h=surf(xt,yt,rimg,mask) ; colorbar ;
%set(h,'EdgeColor','none')
print -deps showbasfn.eps
