function val=tryintfdievalintp(p,th1,th2,u1,u2,T)
val=p ;
for i=1:length(p),
  val(i)=evalintp(p(i),th1,th2,u1,u2,T) ;
end ;
  

function val=evalintp(p,th1,th2,u1,u2,T)
cost=cos(th1) ; sint=sin(th1) ;
x=u1*cost+p*sint ; y=-u1*sint+p*cost ;
val=valvts(th2,u2,T,x,y) ;
%val=valu(p,th1*p+th2) ;

function val=valvts(theta,t,T,x,y) ;
cost=cos(theta) ; sint=sin(theta) ;
xp=cost*x-sint*y ; yp=sint*x+cost*y ;
val=valv(xp,yp,t,T) ; 

function val=valu(xp,yp); 
if xp~=0,
  val=-(0.5*yp*(3*xp^2+yp^2)*log(xp^2+yp^2)+2*xp^3*atan(yp/xp))/12/pi ;
else
  if yp~=0,
    val=-yp^3*log(yp^2)/24/pi ;
  else
    val=0 ;
  end ;
end ;

function val=valv(xp,yp,t,T) ;
st=sqrt(T^2-t^2) ;
val=0.5*(valu(xp-t,yp+st)-valu(xp-t,yp-st)) ;
