% Show the contents of evalfinecrit*.log

tabm=load('evalfinecrit1.log') ;  % Marquardt Levenberg
tabc=load('evalfinecrit2.log') ;  % conjugated gradient
%tabg=load('evalfinecrit3.log') ;  % gradient descent
tabg=load('evalfinecrit4.log') ;  % gradient descent
nm=size(tabm,1) ;
nc=size(tabc,1) ;
ng=size(tabg,1) ;

% Correct jumps - this is a hack !
if 1,
for i=2:nm,
  if tabm(i,3)>tabm(i-1,3),
    tabm(i:nm,1)=tabm(i:nm,1)-tabm(i,1)+tabm(i-1,1)+1 ;
  end ;
end ;
for i=2:nc,
  if tabc(i,3)>tabc(i-1,3),
    tabc(i:nc,1)=tabc(i:nc,1)-tabc(i,1)+tabc(i-1,1)+1 ;
  end ;
end ;
for i=2:ng,
  if tabg(i,3)>tabg(i-1,3),
    tabg(i:ng,1)=tabg(i:ng,1)-tabg(i,1)+tabg(i-1,1)+1 ;
  end ;
end ;

end ;

figure(1) ; clf ;
%semilogx(tabm(:,1),tabm(:,3),tabc(:,1),tabc(:,3),tabg(:,1),tabg(:,3)) ;
plot(tabm(:,1),tabm(:,3),'-',tabc(:,1),tabc(:,3),'--',tabg(:,1),tabg(:,3),'-.') ;
xlabel('iteration') ; ylabel('criterion') ;
legend('ML','GD','CG') ;

figure(2) ; clf ;
tabm(:,2)=tabm(:,2)-tabm(1,2) ;
tabc(:,2)=tabc(:,2)-tabc(1,2) ;
tabg(:,2)=tabg(:,2)-tabg(1,2) ;

%semilogx(1+tabm(:,2),tabm(:,3),1+tabc(:,2),tabc(:,3),1+tabg(:,2),tabg(:,3)) ;
plot(tabm(:,1),tabm(:,3),'-',tabc(:,1),tabc(:,3),'--',tabg(:,1),tabg(:,3),'-.') ;

xlabel('time [s]') ; ylabel('criterion') ;
legend('ML','GD','CG') ;

axis([0 500 0 5e5]) ;
print -deps '/home/jkybic/tex/icip2000/showfineregepafig2.eps'
figure(1) ;
axis([0 1000 0 7e5]) ;
print -deps '/home/jkybic/tex/icip2000/showfineregepafig1.eps'

