function w=fbspline(iorder)
% Calculates (half) of the coefficients of the B-spline direct filter
% w=fbspline(iorder) returns backward bspline coefficients.
% M. Unser / BEIP		Jan-93
%
% $Id: fbspline.m,v 1.1 1999/09/08 17:17:00 jkybic Exp $

  if iorder==0   
			w(1)=1;
  elseif iorder==1   
			w(1)=1;
  elseif iorder==2 
   w=[6 1]./8;
		elseif iorder==3
   w=[4 1]./6;
		elseif iorder==4
   w=[230 76 1]./384;
		elseif iorder==5
   w=[66 26 1]./120;
		elseif iorder==6
   w=[23548 10543 722 1]./46080;
		elseif iorder==7
   w=[2416 1191 120 1]./5040;
  else
    error('Order not available')
    return
  end
