% Test deftable
%
% Jan Kybic, 1999
% $Id: trydeftable.m,v 1.7 1999/11/16 15:19:53 jkybic Exp $

%%%%% 1D
if 0,
figure(1) ; title('1D test') ;
img=[ 10 5 4 3 3 6 8 2 1 10 ]' ; 
imsize=length(img) ;
c=[ 1 1 1 1 1 ] ;
imgb3=fsplinem(img,3) ;
tbl=deftable(c,imsize,3) ;
imgw=mexsplninterp(imgb3,tbl,1,3) ; 
plot(1:imsize,img,1:imsize,imgw) ;
end ;

%%%% 2D
if 0,
figure(2) ; title('2D test') ;
img=double(imread('/home/jkybic/people/philippe/reg/barb.TIFF')) ;
imsize=size(img) ;
c=zeros(2,4,4) ;
c(1,3,3)=500 ;
disp('Bspln transf') ;
imgb3=fsplinem(img,3) ;
disp('deftable') ;
tbl=deftable(c,imsize,3) ;
disp('splninterp') ;
imgw=mexsplninterp(imgb3,tbl,2,3) ; 
disp('displaying') ;
imagesc(imgw) ; colormap(pink) ; axis image ;
end ;

%%%% 3D
if 1,
figure(3) ;title('3D test') ;
img1=double(imread('/home/jkybic/people/philippe/reg/barb.TIFF')) ;
img2=double(imread('/home/jkybic/people/philippe/reg/einstein.TIFF')) ;
[ny,nx]=size(img1) ;
img=zeros(ny,nx,2) ;
img(:,:,1)=double(img1) ; img(:,:,2)=double(img2) ;
imsize=size(img);
c=zeros(3,4,4,4) ;
c(3,3,3,3)=5 ;
c(3,2,1,1)=-5 ;
disp('Bspln transf') ;
imgb3=fsplinem(img,3) ;
disp('deftable') ;
tbl=deftable(c,imsize,3) ;
disp('splninterp') ;
imgw=mexsplninterp(imgb3,tbl,3,3) ; 
disp('displaying') ;
subplot(211) ; imagesc(imgw(:,:,1)) ; colormap(pink) ; axis image ;
subplot(212) ; imagesc(imgw(:,:,2)) ; colormap(pink) ; axis image ;
end ;