% Register EP SPECT images

% read images
clear all
if 0,
  epA=readnema('/home/jkybic/uge/sujet-A_EP-r199907091642.nema',[64 64 18]) ;
  epA=epA(:,:,1:17) ;
  %epC=readnema('/home/jkybic/uge/sujet-C_EP-r199907091534.nema',[64 64 17]) ;
  %epC=epC(:,:,1:17) ;
  imsize=size(epA) ;

  % generate random deformation
  randn('state',sum(100*clock)) ;
  % sigma=3 ;
  sigma=1 ;
  disp('random gen.') ;
  c0=zeros(3,6,6,6) ;
  c1=sigma*randn(3,8,8,8) ; 
  alpha=1e-3 ; degc=2 ; degft=3 ;
  %save epapar1 c0 c1 epA imsize degc degft alpha sigma
else
  load epapar1
end ;

disp('bsplntransf') ;
epAb=fsplinem(epA,degft) ;
% epCb=fsplinem(epC,degft) ;
disp('deftable') ;
tbl=deftable(c1,imsize,degc) ;
disp('splninterp') ;
epAd=mexsplninterp(epAb,tbl,3,degft) ;

testimg=epA ;
refimg=epAd ;
testimgb=epAb ;
save regepaimgs testimg refimg testimgb degc degft c0
clear testimg refimg testimgb 

cc=cputime ;
c2=regoptpyr(epAd,epA,c0,alpha,3) ;
% c2=regopt(epAd,epA,c0,alpha) ;
disp([ 'Registration took ' num2str(cputime-cc) ' s']) ;
save regepafine c2
disp('deftable') ;
tbl2=deftable(c2,imsize,degc) ;
disp('splninterp') ;
epAw=mexsplninterp(epAb,tbl2,3,degft) ;

sum(sum(sum((epAd-epA).^2)))
sum(sum(sum((epAd-epAw).^2)))
subplot(211) ; imagesc([ epAd(:,:,10) epA(:,:,10)]) ;
title('reference/test') ; colormap(pink) ;
subplot(212) ; imagesc([ epAd(:,:,10)-epA(:,:,10) epAd(:,:,10)-epAw(:,:,10)]) ;
colorbar ; title('before/after') ; 
