% Register ECD SPECT images
% This time we register the real images (not artificially deformed)

% read images
clear all
if 1,
  ecdB=readnema('/home/jkybic/uge/sujet-B_TRA_OM-r199907081155.nema',[128 128 33]) ;
  ecdB=normalize(ecdB(:,:,1:32)) ;
  ecdC=readnema('/home/jkybic/uge/sujet-C_TRA_OM-r199907091558.nema',[128 128 34]) ;
  ecdC=normalize(ecdC(:,:,1:32)) ;
  figure(1)
  subplot(311) ;
  imagesc([ ecdC(:,:,20) ecdB(:,:,20)]) ;
  title('reference/test') ; colormap(gray) ; colorbar ; axis off ; axis image
  % print -deps regeparealfig2.eps
  ecdB=imhisteq(ecdC,ecdB) ;
  imsize=size(ecdB) ;
  c0=zeros(3,6,6,4) ;
  alpha=1e-1 ; degc=2 ; degft=3 ;
  save epapar4 c0  ecdB ecdC imsize degc degft alpha 
else
  load epapar4
end ;

figure(2)
testimg=ecdB ;
refimg=ecdC ;
sum(sum(sum((refimg-testimg).^2)))
subplot(211) ; imagesc([ refimg(:,:,20) testimg(:,:,20)]) ;

title('reference/test') ; colormap(gray) ; axis image ; axis off ; colorbar

pause(0.01)

disp('bsplntransf') ;
ecdBb=fsplinem(ecdB,degft) ;
%epCb=fsplinem(epC,degft) ;

save regepa4imgs testimg refimg  degc degft c0
%clear testimg refimg testimgb 

cc=cputime ;
if 1,
 c2=regoptpyr(refimg,testimg,c0,alpha,5,1) ; % end at level 1
 disp([ 'Registration took ' num2str(cputime-cc) ' s']) ;
 save regepa4fine c2
else
 load regepa4fine
end ;

disp('deftable') ;
tbl2=deftable(c2,imsize,degc) ;
disp('splninterp') ;
Aw=mexsplninterp(ecdBb,tbl2,3,degft) ;

sum(sum(sum((refimg-Aw).^2)))
subplot(313) ; imagesc(([ refimg(:,:,20)-testimg(:,:,20) refimg(:,:,20)-Aw(:,:,20)])) ;
colorbar ; title('before/after') ; axis image ; axis off

print -deps regeparealfig1.eps